{***************************************************************
 *
 * Unit Name : Childwin
 * Purpose   : MDI Text Editor
 * Author    : Eugen Mihailescu
 * Company   : EM Quicksoft Romania SRL
 * Copyright : 1998,2002  All rights reserved.
 * Web Site  : http://www.em-quicksoft.com
 * Support   : support@em-quicksoft.com
 * History   : 03/17/2000
 *
 ****************************************************************}

Unit Childwin;

Interface

Uses
  SysUtils,
  Windows,
  Messages,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  Menus,
  ComCtrls,
  ToolWin,
  ExtCtrls,
  StdCtrls,
  IniFiles,
  Mask;

Type
  TMDIChild = Class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Edit1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    N3: TMenuItem;
    Selectall1: TMenuItem;
    Character1: TMenuItem;
    Left1: TMenuItem;
    Right1: TMenuItem;
    Center1: TMenuItem;
    N4: TMenuItem;
    Wordwrap1: TMenuItem;
    N5: TMenuItem;
    Font1: TMenuItem;
    Editor: TRichEdit;
    PopupMenu1: TPopupMenu;
    Cut2: TMenuItem;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    SaveFileDialog: TSaveDialog;
    FontDialog1: TFontDialog;
    Printersetup1: TMenuItem;
    Close1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    PrintDialog1: TPrintDialog;
    StatusBar1: TStatusBar;
    ControlBar1: TControlBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    FindDialog1: TFindDialog;
    ReplaceDialog1: TReplaceDialog;
    N1: TMenuItem;
    Find1: TMenuItem;
    Replace1: TMenuItem;
    ToolBar2: TToolBar;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ZoomPerc: TMaskEdit;
    Procedure Exit1Click(Sender: TObject);
    Procedure New1Click(Sender: TObject);
    Procedure AlignClick(Sender: TObject);
    Procedure Wordwrap1Click(Sender: TObject);
    Procedure Cut1Click(Sender: TObject);
    Procedure Copy1Click(Sender: TObject);
    Procedure Paste1Click(Sender: TObject);
    Procedure Selectall1Click(Sender: TObject);
    Procedure Delete1Click(Sender: TObject);
    Procedure Edit1Click(Sender: TObject);
    Procedure SaveAs1Click(Sender: TObject);
    Procedure Save1Click(Sender: TObject);
    Procedure Font1Click(Sender: TObject);
    Procedure Close1Click(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure Printersetup1Click(Sender: TObject);
    Procedure Print1Click(Sender: TObject);
    Procedure Open1Click(Sender: TObject);
    Procedure EditorKeyUp(Sender: TObject; Var Key: Word;
      Shift: TShiftState);
    Procedure ToolButton1Click(Sender: TObject);
    Procedure ToolButton2Click(Sender: TObject);
    Procedure ToolButton3Click(Sender: TObject);
    Procedure EditorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    Procedure ToolButton5Click(Sender: TObject);
    Procedure HistoryItemClick(Sender: TObject);
    Procedure EditorKeyDown(Sender: TObject; Var Key: Word;
      Shift: TShiftState);
    Procedure Replace1Click(Sender: TObject);
    Procedure FindDialog1Find(Sender: TObject);
    Procedure Find1Click(Sender: TObject);
    Procedure ToolButton6Click(Sender: TObject);
    Procedure ToolButton7Click(Sender: TObject);
    Procedure ZoomPercExit(Sender: TObject);
    Procedure ReplaceDialog1Replace(Sender: TObject);
  private
    { Private declarations }
  public
    PathName: String;
    Zoom: Integer;
    { Public declarations }
    Procedure Open(Const AFileName: String);
    Procedure GetKeyState;
    Procedure ArangeList(Sender: TObject);
    Procedure ReArangeList(Sender: TObject; FirstItem: String);
  End;

Var
  MDIChild          : TMDIChild;
  S                 : Array[1..10] Of String;

Const
  DefaultFileName   = 'Untitled';

Implementation

Uses Main,
  Clipbrd,
  Printers;

{$R *.DFM}
//******************* TMDIChild.Exit1Click *************************

Procedure TMDIChild.Exit1Click(Sender: TObject);
Begin
  MainForm.FileExit1Execute(Sender);
End;
//******************* TMDIChild.New1Click *************************

Procedure TMDIChild.New1Click(Sender: TObject);
Begin
  MainForm.FileNew1Execute(Sender);
End;
//******************* TMDIChild.Open1Click *************************

Procedure TMDIChild.Open1Click(Sender: TObject);
Begin
  MainForm.FileOpen1Execute(Sender);
End;
//******************* TMDIChild.AlignClick *************************

Procedure TMDIChild.AlignClick(Sender: TObject);
Begin
  Left1.Checked := False;
  Right1.Checked := False;
  Center1.Checked := False;
  With Sender As TMenuItem Do
    Checked := True;
  With Editor.Paragraph Do
    If Left1.Checked Then
      Alignment := taLeftJustify
    Else
      If Right1.Checked Then
      Alignment := taRightJustify
    Else
      If Center1.Checked Then
      Alignment := taCenter;
End;
//******************* TMDIChild.Wordwrap1Click *************************

Procedure TMDIChild.Wordwrap1Click(Sender: TObject);
Begin
  With Editor Do
    Begin
      WordWrap := Not WordWrap;         { toggle word wrapping }
      If WordWrap Then
        ScrollBars := ssVertical
      Else
        ScrollBars := ssBoth;
      WordWrap1.Checked := WordWrap;    { set menu item check }
    End;
End;
//******************* TMDIChild.Cut1Click *************************

Procedure TMDIChild.Cut1Click(Sender: TObject);
Begin
  Editor.CutToClipboard;
End;
//******************* TMDIChild.Copy1Click *************************

Procedure TMDIChild.Copy1Click(Sender: TObject);
Begin
  Editor.CopyToClipboard;
End;
//******************* TMDIChild.Paste1Click *************************

Procedure TMDIChild.Paste1Click(Sender: TObject);
Begin
  Editor.PasteFromClipboard;
End;
//******************* TMDIChild.Selectall1Click *************************

Procedure TMDIChild.Selectall1Click(Sender: TObject);
Begin
  Editor.SelectAll;
End;
//******************* TMDIChild.Delete1Click *************************

Procedure TMDIChild.Delete1Click(Sender: TObject);
Begin
  Editor.ClearSelection;
End;
//******************* TMDIChild.Edit1Click *************************

Procedure TMDIChild.Edit1Click(Sender: TObject);
Var
  HasSelection      : Boolean;
Begin
  Paste1.Enabled := Clipboard.HasFormat(CF_TEXT);
  Paste2.Enabled := Paste1.Enabled;
  HasSelection := Editor.SelLength > 0;
  Cut1.Enabled := HasSelection;
  Cut2.Enabled := HasSelection;
  Copy1.Enabled := HasSelection;
  Copy2.Enabled := HasSelection;
  Delete1.Enabled := HasSelection;
End;
//******************* TMDIChild.Open *************************

Procedure TMDIChild.Open(Const AFileName: String);
Begin
  PathName := AFileName;
  Caption := ExtractFileName(AFileName);
  With Editor Do
    Begin
      Lines.LoadFromFile(PathName);
      SelStart := 0;
      Modified := False;
    End;
End;
//******************* TMDIChild.Saveas1Click *************************

Procedure TMDIChild.SaveAs1Click(Sender: TObject);
Begin
  SaveFileDialog.FileName := PathName;
  If SaveFileDialog.Execute Then
    Begin
      If Extractfileext(SaveFileDialog.FileName) = '' Then
        PathName := SaveFileDialog.FileName + '.rom'
      Else
        PathName := SaveFileDialog.FileName;
      Caption := ExtractFileName(PathName);
      Save1Click(Sender);
      MainForm.RearangeList(Self, '&1 ' + PathName);
    End;
End;
//******************* TMDIChild.Save1Click *************************

Procedure TMDIChild.Save1Click(Sender: TObject);
Begin
  If PathName = DefaultFileName Then
    SaveAs1Click(Sender)
  Else
    Begin
      Editor.Lines.SaveToFile(PathName);
      Editor.Modified := False;
    End;
End;
//******************* TMDIChild.Font1Click *************************

Procedure TMDIChild.Font1Click(Sender: TObject);
Begin
  FontDialog1.Font := Editor.Font;
  If FontDialog1.Execute Then
    Editor.SelAttributes.Assign(FontDialog1.Font);
End;
//******************* TMDIChild.Close1Click *************************

Procedure TMDIChild.Close1Click(Sender: TObject);
Begin
  Close;
End;
//******************* TMDIChild.FormClose *************************

Procedure TMDIChild.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  Action := caFree;
End;
//******************* TMDIChild.FormCloseQuery *************************

Procedure TMDIChild.FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
Const
  SWarningText      = 'Save changes to %s?';
Begin
  If Editor.Modified Then
    Begin
      Case MessageDlg(Format(SWarningText, [PathName]), mtConfirmation,
        [mbYes, mbNo, mbCancel], 0) Of
        idYes: Save1Click(Self);
        IDCANCEL: CanClose := False;
      End;
    End;
End;
//******************* TMDIChild.FormCreate *************************

Procedure TMDIChild.FormCreate(Sender: TObject);
Var
  Key               : Word;
Begin
  ArangeList(Self);
  Key := 0;
  PathName := DefaultFileName;
  EditorKeyUp(Self, Key, [ssShift]);
  Zoom := 0;
End;
//******************* TMDIChild.Printersetup1Click *************************

Procedure TMDIChild.Printersetup1Click(Sender: TObject);
Begin
  PrinterSetupDialog1.Execute;
End;
//******************* TMDIChild.Print1Click *************************

Procedure TMDIChild.Print1Click(Sender: TObject);
Begin
  If PrintDialog1.Execute Then
    Editor.Print(PathName);
End;
//******************* TMDIChild.EditorKeyUp *************************

Procedure TMDIChild.EditorKeyUp(Sender: TObject; Var Key: Word;
  Shift: TShiftState);
Begin
  StatusBar1.Panels.Items[0].Text := 'Line: ' + IntToStr(Editor.caretpos.Y + 1);
  StatusBar1.Panels.Items[1].Text := 'Col: ' + IntToStr(Editor.caretpos.X + 1);
  GetKeyState;
  Application.ProcessMessages;
End;
//******************* TMDIChild.ToolButton1Click *************************

Procedure TMDIChild.ToolButton1Click(Sender: TObject);
Begin
  With Editor.Paragraph Do
    Alignment := taLeftJustify;
End;
//******************* TMDIChild.ToolButton2Click *************************

Procedure TMDIChild.ToolButton2Click(Sender: TObject);
Begin
  With Editor.Paragraph Do
    Alignment := taCenter;
End;
//******************* TMDIChild.ToolButton3Click *************************

Procedure TMDIChild.ToolButton3Click(Sender: TObject);
Begin
  With Editor.Paragraph Do
    Alignment := taRightJustify;
End;
//******************* TMDIChild.EditorMouseDown *************************

Procedure TMDIChild.EditorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
Begin
  StatusBar1.Panels.Items[0].Text := 'Line: ' + IntToStr(Editor.caretpos.Y + 1);
  StatusBar1.Panels.Items[1].Text := 'Col: ' + IntToStr(Editor.caretpos.X + 1);
  GetKeyState;
  Application.ProcessMessages;
End;
//******************* TMDIChild.GetKeyState *************************

Procedure TMDIChild.GetKeyState;
Var
  KeyState          : TKeyboardState;
Begin
  GetKeyboardState(KeyState);
  Case KeyState[VK_INSERT] Of
    1: StatusBar1.Panels.Items[2].Text := 'Insert';
    0: StatusBar1.Panels.Items[2].Text := 'Overwrite';
  End;
  Case KeyState[VK_CAPITAL] Of
    1: StatusBar1.Panels.Items[3].Text := 'CAPS';
    0: StatusBar1.Panels.Items[3].Text := 'NO CAPS';
  End;
  Case KeyState[VK_NUMLOCK] Of
    1: StatusBar1.Panels.Items[4].Text := 'NUMLOCK';
    0: StatusBar1.Panels.Items[4].Text := 'NO NUMLOCK';
  End;
End;
//******************* TMDIChild.ToolButton5Click *************************

Procedure TMDIChild.ToolButton5Click(Sender: TObject);
Begin
  MessageDlg('Not available in this version.Please contact your software vendor.', mtInformation, [mbOK], 0);
End;
//******************* TMDIChild.ArangeList *************************

Procedure TMDIChild.ArangeList(Sender: TObject);
Var
  F                 : TIniFile;
  Count, k          : Integer;
  NewItem           : TMenuItem;
Begin
  For k := 9 To File1.Count - 1 Do
    File1.Delete(9);
  NewItem := TMenuItem.Create(Self);
  NewItem.Caption := '-';
  File1.Add(NewItem);
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings.ini');
  Try
    Count := F.ReadInteger('ROMFiles', 'FilesCount', 5);

    For k := 1 To Count Do
      Begin
        NewItem := TMenuItem.Create(Self);
        S[k] := F.ReadString('ROMFiles', 'FILE_' + IntToStr(k), '');
        If (Trim(S[k]) <> '') Then
          Begin
            If k < 10 Then
              NewItem.Caption := '&' + IntToStr(k) + #32 + S[k]
            Else
              NewItem.Caption := IntToStr(k) + #32 + S[k];
            NewItem.OnClick := HistoryItemClick;
            File1.Add(NewItem);
          End;
      End;
  Finally
    F.Free;
  End;
  If File1.Count = 10 Then File1.Delete(9);
End;
//******************* TMDIChild.ReArangeList *************************

Procedure TMDIChild.ReArangeList(Sender: TObject; FirstItem: String);
Var
  F                 : TIniFile;
  Count, k          : Integer;
  ys, xs, zs        : String;
  Found             : Boolean;
Begin
  F := TIniFile.Create(ExtractFilePath(Application.ExeName) + 'Settings.ini');
  Try
    Count := F.ReadInteger('ROMFiles', 'FilesCount', 5);
    For k := 1 To Count Do
      S[k] := F.ReadString('ROMFiles', 'FILE_' + IntToStr(k), '');
    Found := False;
    For k := 1 To Count Do
      Begin
        ys := Copy(FirstItem, Pos(#32, FirstItem) + 1, Length(FirstItem));
        xs := S[k];
        If xs = ys Then
          Begin
            Found := True;
            zs := S[1];
            S[1] := Copy(FirstItem, Pos(#32, FirstItem) + 1, Length(FirstItem));
            S[k] := zs;
            Break;
          End;
      End;
    If Not Found Then
      Begin
        For k := Count - 1 Downto 1 Do
          S[k + 1] := S[k];
        S[1] := Copy(FirstItem, Pos(#32, FirstItem) + 1, Length(FirstItem));
      End;
    For k := 1 To Count Do
      F.WriteString('ROMFiles', 'FILE_' + IntToStr(k), S[k]);

  Finally
    F.Free;
  End;
  ArangeList(Self);
End;
//******************* TMDIChild.HistoryItemClick *************************

Procedure TMDIChild.HistoryItemClick(Sender: TObject);
Var
  Item              : TMenuItem;
Begin
  With Sender As TMenuItem Do
    Begin
      Item := TMenuItem.Create(Self);
      Try
        Item := Sender As TMenuItem;
        MainForm.CreateMDIChild(Copy(Item.Caption, Pos(#32, Item.Caption) + 1, Length(Item.Caption)));
        RearangeList(Self, Item.Caption);
      Finally
        Item.Free;
      End;
    End;
End;
//******************* TMDIChild.EditorKeyDown *************************

Procedure TMDIChild.EditorKeyDown(Sender: TObject; Var Key: Word;
  Shift: TShiftState);
Begin
  StatusBar1.Panels.Items[0].Text := 'Line: ' + IntToStr(Editor.caretpos.Y + 1);
  StatusBar1.Panels.Items[1].Text := 'Col: ' + IntToStr(Editor.caretpos.X + 1);
  GetKeyState;
  Application.ProcessMessages;
End;

//******************* TMDIChild.Replace1Click *************************

Procedure TMDIChild.Replace1Click(Sender: TObject);
Begin
  If ReplaceDialog1.Execute Then
End;
//******************* TMDIChild.FindDialog1Find *************************

Procedure TMDIChild.FindDialog1Find(Sender: TObject);
Var
  FoundAt           : Longint;
  StartPos, ToEnd   : Integer;
Begin
  With Editor Do
    Begin
      If SelLength <> 0 Then
        StartPos := SelStart + SelLength
      Else
        StartPos := 0;
      ToEnd := Length(Text) - StartPos;
      FoundAt := FindText(FindDialog1.FindText, StartPos, ToEnd, []);
      If FoundAt <> -1 Then
        Begin
          SelStart := FoundAt;
          SelLength := Length(FindDialog1.FindText);
          SetFocus;
        End
      Else
        MessageDlg('Search string ''' + FindDialog1.FindText + ''' not found', mtInformation, [mbOK], 0);
    End;
End;
//******************* TMDIChild.Find1Click *************************

Procedure TMDIChild.Find1Click(Sender: TObject);
Begin
  FindDialog1.Execute;
End;
//******************* TMDIChild.ToolButton6Click *************************

Procedure TMDIChild.ToolButton6Click(Sender: TObject);
Begin
  Editor.ScaleBy(100 + Zoom, 100);
End;
//******************* TMDIChild.ToolButton7Click *************************

Procedure TMDIChild.ToolButton7Click(Sender: TObject);
Begin
  Zoom := Zoom + 50;
  Editor.ScaleBy(50, 100);
End;
//******************* TMDIChild.ZoomPercExit *************************

Procedure TMDIChild.ZoomPercExit(Sender: TObject);
Begin
  If Trim(ZoomPerc.Text) <> '' Then
    Editor.ScaleBy(StrToInt(ZoomPerc.Text), 100);
End;
//******************* TMDIChild.ReplaceDialog1Replace *************************

Procedure TMDIChild.ReplaceDialog1Replace(Sender: TObject);
Begin
  If Not (frReplaceAll In replacedialog1.Options) Then
    Begin
      Editor.Text := StringReplace(Editor.Text, ReplaceDialog1.FindText, ReplaceDialog1.ReplaceText, [rfIgnoreCase]);
    End
  Else
    Begin
      Editor.Text := StringReplace(Editor.Text, ReplaceDialog1.FindText, ReplaceDialog1.ReplaceText, [rfReplaceAll, rfIgnoreCase]);
    End;
End;

End.

